<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeneralDeviceNote StructType
 * @subpackage Structs
 */
class GeneralDeviceNote extends AbstractStructBase
{
    /**
     * The CreateDateTimeUTC
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreateDateTimeUTC;
    /**
     * The ModifiedDateTimeUTC
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ModifiedDateTimeUTC;
    /**
     * The TextDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TextDescription;
    /**
     * The LastModifiedByRep
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastModifiedByRep;
    /**
     * The Images
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage
     */
    public $Images;
    /**
     * Constructor method for GeneralDeviceNote
     * @uses GeneralDeviceNote::setCreateDateTimeUTC()
     * @uses GeneralDeviceNote::setModifiedDateTimeUTC()
     * @uses GeneralDeviceNote::setTextDescription()
     * @uses GeneralDeviceNote::setLastModifiedByRep()
     * @uses GeneralDeviceNote::setImages()
     * @param string $createDateTimeUTC
     * @param string $modifiedDateTimeUTC
     * @param string $textDescription
     * @param string $lastModifiedByRep
     * @param \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage $images
     */
    public function __construct($createDateTimeUTC = null, $modifiedDateTimeUTC = null, $textDescription = null, $lastModifiedByRep = null, \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage $images = null)
    {
        $this
            ->setCreateDateTimeUTC($createDateTimeUTC)
            ->setModifiedDateTimeUTC($modifiedDateTimeUTC)
            ->setTextDescription($textDescription)
            ->setLastModifiedByRep($lastModifiedByRep)
            ->setImages($images);
    }
    /**
     * Get CreateDateTimeUTC value
     * @return string
     */
    public function getCreateDateTimeUTC()
    {
        return $this->CreateDateTimeUTC;
    }
    /**
     * Set CreateDateTimeUTC value
     * @param string $createDateTimeUTC
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public function setCreateDateTimeUTC($createDateTimeUTC = null)
    {
        // validation for constraint: string
        if (!is_null($createDateTimeUTC) && !is_string($createDateTimeUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createDateTimeUTC, true), gettype($createDateTimeUTC)), __LINE__);
        }
        $this->CreateDateTimeUTC = $createDateTimeUTC;
        return $this;
    }
    /**
     * Get ModifiedDateTimeUTC value
     * @return string
     */
    public function getModifiedDateTimeUTC()
    {
        return $this->ModifiedDateTimeUTC;
    }
    /**
     * Set ModifiedDateTimeUTC value
     * @param string $modifiedDateTimeUTC
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public function setModifiedDateTimeUTC($modifiedDateTimeUTC = null)
    {
        // validation for constraint: string
        if (!is_null($modifiedDateTimeUTC) && !is_string($modifiedDateTimeUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modifiedDateTimeUTC, true), gettype($modifiedDateTimeUTC)), __LINE__);
        }
        $this->ModifiedDateTimeUTC = $modifiedDateTimeUTC;
        return $this;
    }
    /**
     * Get TextDescription value
     * @return string|null
     */
    public function getTextDescription()
    {
        return $this->TextDescription;
    }
    /**
     * Set TextDescription value
     * @param string $textDescription
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public function setTextDescription($textDescription = null)
    {
        // validation for constraint: string
        if (!is_null($textDescription) && !is_string($textDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($textDescription, true), gettype($textDescription)), __LINE__);
        }
        $this->TextDescription = $textDescription;
        return $this;
    }
    /**
     * Get LastModifiedByRep value
     * @return string|null
     */
    public function getLastModifiedByRep()
    {
        return $this->LastModifiedByRep;
    }
    /**
     * Set LastModifiedByRep value
     * @param string $lastModifiedByRep
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public function setLastModifiedByRep($lastModifiedByRep = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedByRep) && !is_string($lastModifiedByRep)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModifiedByRep, true), gettype($lastModifiedByRep)), __LINE__);
        }
        $this->LastModifiedByRep = $lastModifiedByRep;
        return $this;
    }
    /**
     * Get Images value
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage|null
     */
    public function getImages()
    {
        return $this->Images;
    }
    /**
     * Set Images value
     * @param \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage $images
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public function setImages(\CustomerManagement\ArrayType\ArrayOfDeviceNoteImage $images = null)
    {
        $this->Images = $images;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\GeneralDeviceNote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
